var Tinkerforge = require('../Tinkerforge')
,   Conf        = require('./config.json')
,   Helper      = require('../Adawim/helper')
,   Log         = require('../Adawim/logging')
,   http        = require('http');


Helper.each(Conf.items, function(item) {  
  connect(item);
});


/* private */
function reconnect(item) {
  Log.debug('Reconnect ' + item.host);
  setTimeout(function() { connect(item) }, 10000);
}

/* private */
function connect(item) {
  var HOST = item.host;
  var PORT = item.port;
  var UID = item.uid;

  Log.log('Init ' + UID + ' @' + HOST);
  
  var ipcon = new Tinkerforge.IPConnection(); // Create IP connection
  var dus = new Tinkerforge.BrickletDistanceIR(UID, ipcon); // Create device object
  
  var counter = 0;
  var readyForNextNotification = true;
  
  ipcon.connect(HOST, PORT,
    function (error) {
    
      /*
        IPConnection.ERROR_ALREADY_CONNECTED = 11
        IPConnection.ERROR_NOT_CONNECTED = 12
        IPConnection.ERROR_CONNECT_FAILED = 13
        IPConnection.ERROR_INVALID_FUNCTION_ID = 21
        IPConnection.ERROR_TIMEOUT = 31
        IPConnection.ERROR_INVALID_PARAMETER = 41
        IPConnection.ERROR_FUNCTION_NOT_SUPPORTED = 42
        IPConnection.ERROR_UNKNOWN_ERROR = 43
      */
    
      Log.error('Error @'+HOST+': ' + error);
      
      if(error === 13) {
        reconnect(item);
      }
    }
  ); // Connect to brickd
  // Don't use device before ipcon is connected
  
  ipcon.on(Tinkerforge.IPConnection.CALLBACK_CONNECTED,
    function (connectReason) {
      // Set period for distance value callback to 0.2s (200ms)
      // Note: The distance value callback is only called every 0.2 seconds
      //       if the distance value has changed since the last call!
      dus.setDistanceCallbackPeriod(5000);
    }
  );
  
  // Register distance value callback
  dus.on(Tinkerforge.BrickletDistanceIR.CALLBACK_DISTANCE,
    // Callback function for distance value callback
    function (distance) {
      Log.log('Distance Value: ' + distance);
      
      if(distance < item.value) {
        doDoorStateChangedCall(HOST, item.on.action.open);
      } else {
        doDoorStateChangedCall(HOST, item.on.action.closed);
      }
    }
  );
  
  process.on( 'SIGINT', function() {
    Log.log( "Gracefully disconnect " + HOST );
    ipcon.disconnect();
    process.exit( );
  });
}

/* private */
function doDoorStateChangedCall(host, options) {
  const HOST = host;
  
  Log.inspect('Call options', options);
  
  callback = function(response) {
    var str = '';

    //another chunk of data has been recieved, so append it to `str`
    response.on('data', function (chunk) {
      str += chunk;
    });

    //the whole response has been recieved, so we just print it out here
    response.on('end', function () {
      Log.log(HOST + ': ' + str);
    });
  }

  var req = http.request(options, function(res) {
    //Log.inspect('Result', res);
  });

  req.on('error', function(err) {
    if(HOST) {
      Log.error(HOST + ': ' + err);
    } else {
      Log.error(err);
    }
  });
  
  req.end();
}